<?php
namespace Indeterminado\Repositories;

class Vencservprop extends \Doctrine\ORM\EntityRepository
{
    public function parcelasServicos($proposta, $versao){
        $sql = "SELECT MIN(DTVENCSERVPROP) AS DTVENCSERVPROP
                  FROM VENCSERVPROP
                 WHERE NRPROPOSFAS = :P_NRPROPOSFAS
                   AND NRVERPROPFAS = :P_NRVERPROPFAS
                   AND NRORG = 1
                 ORDER BY DTVENCSERVPROP";

        $params = array(
            "P_NRPROPOSFAS"     => $proposta,
            "P_NRVERPROPFAS"    => $versao,
        );

        $result = $this->_em->getConnection()->fetchColumn($sql, $params);

        return $result;
    }
    public static function getParcelasNegociarServicos($nrProposta, $nrVersao)
    {
        $sql = "SELECT VC.DTVENCSERVPROP, VC.NRPROPOSFAS, VC.NRVERPROPFAS, 
                       VC.VRVENCSERVPROP, VC.NRORG, ROWNUM AS NRPARCELA
                  FROM (SELECT DTVENCSERVPROP, NRPROPOSFAS, NRVERPROPFAS, 
                        VRVENCSERVPROP, NRORG
                        FROM VENCSERVPROP
                       WHERE NRPROPOSFAS = :P_NRPROPOSFAS
                         AND NRVERPROPFAS = :P_NRVERPROPFAS
                       ORDER BY DTVENCSERVPROP) VC
                 ORDER BY VC.DTVENCSERVPROP";
        
        $params = array(
            "P_NRPROPOSFAS"  => $nrProposta,
            "P_NRVERPROPFAS" => $nrVersao
        );
        
         try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }
}