/*+
|                                               |
|     Trigger: DTULTATU_ITEMDW                  |  
|     Tabela : ITEMDW                           |
|                                               |
|     Criao:                                  |
|     11/09/2007 - Luiz Passos                  |
|                                               |
+*/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ITEMDW'  and
            type = 'TR'                 and
            u.uid = o.uid               and
            u.name = USER)
   DROP TRIGGER DTULTATU_ITEMDW
GO

CREATE TRIGGER DTULTATU_ITEMDW
ON ITEMDW
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, DSKEYCACHE, DTULTATUCACH)
         (SELECT 'ITEMDW', 'CDTABELADW='   + CDTABELADW +
                           ';CDITEMDW='   + CDITEMDW  + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE ITEMDW
      SET DTULTATUITDW = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(ITEMDW.CDTABELADW, 0)  = ISNULL(INSERTED.CDTABELADW, 0))   AND
            (ISNULL(ITEMDW.CDITEMDW, 0)    = ISNULL(INSERTED.CDITEMDW, 0));

   END;
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_ITEMDW','4.11.176';
GO

