#!/bin/sh

MCSV_PRODUCT_PATH=/var/www/equipe_teste/php7/pebbian/fin
SCRIPTS_PATH="$MCSV_PRODUCT_PATH/ci_scripts/"
MODULE_NAME='fin'  
VERSION=$(date +%s)                  
MCSV_MODULE_SERVICE_PATH="$MCSV_PRODUCT_PATH/modules/$MODULE_NAME"
MCSV_MODULE_BACKEND_PATH="$MCSV_PRODUCT_PATH/modules/teknisa/$MODULE_NAME"
REPORTS_CONFIG_PATH="$MCSV_MODULE_BACKEND_PATH/reports"                     
ZEEDHI_TEST_PRODUCTS_PATH="/var/www/equipe_teste/zeedhi/test_products/organizationManagement/modules_php7"
LTS_TEST_MCSV_PRODUCT_PATH="/var/www/equipe_teste/php7/pebbian/erp"  
ALIAS_SUB_RELEASE_TEST_PRODUCT_PATH=fin
ALIAS_LTS_TEST_PRODUCT_PATH="erp"
DEVOPS_VERSION="2"
DEVOPS_REVISION="21"
DEVOPS_BUILD="7"
#NEEDED_PRODUCTS_TEST_PATH="/var/www/equipe_teste/php7/pebbian/erp/modules"

#if [ ! -d $MCSV_PRODUCT_PATH/backend/ ]; then
	#echo 'Copy another microservice product to current sub-release folder ----------'
	#cp -R $LTS_TEST_MCSV_PRODUCT_PATH/backend/ $MCSV_PRODUCT_PATH
	#cp -R $LTS_TEST_MCSV_PRODUCT_PATH/mobile/  $MCSV_PRODUCT_PATH
    
    #echo "Update Project product path to it's Sub-Release's path ------------------"
	#$SCRIPTS_PATH/replace.sh "$ALIAS_LTS_TEST_PRODUCT_PATH"  "$ALIAS_SUB_RELEASE_TEST_PRODUCT_PATH" "$MCSV_PRODUCT_PATH/mobile/assets/js/environment.js"
	#$SCRIPTS_PATH/replace.sh "$ALIAS_LTS_TEST_PRODUCT_PATH"  "$ALIAS_SUB_RELEASE_TEST_PRODUCT_PATH" "$MCSV_PRODUCT_PATH/mobile/assets/json/modules.json"
#fi

echo 'Front step -----------------------------------------------------'
{ # try !
    cd $MCSV_MODULE_SERVICE_PATH/mobile
	#$SCRIPTS_PATH/front_step.sh
	$SCRIPTS_PATH/front_step_new.sh
} || { # catch!
    echo 'Front Step Error -------------------------------------------------------'
    exit 1
}

echo 'Run grunt tasks for test -------------------------------------------------'
grunt buildEnvironment:test
grunt buildAclStruct

echo 'Environment mnemonics ----------------------------------------------------'
$SCRIPTS_PATH/env_mnemonics.sh $SCRIPTS_PATH $MCSV_MODULE_SERVICE_PATH "https:\/\/storage\.teknisa\.com\/backend\/index\.php" "https:\/\/zhreports\.teknisa\.cloud" "pt_br" "false"

echo 'Update Version -----------------------------------------------------------'
$SCRIPTS_PATH/replace.sh "<>APPLICATION_VERSION<>" "$VERSION" "bower.json"

echo 'Backend mnemonics --------------------------------------------------------'
cd $MCSV_MODULE_SERVICE_PATH/backend/config

#echo 'Update db.xml ------------------------------------------------------------'
#$SCRIPTS_PATH/db_mnemonics.sh $SCRIPTS_PATH "USR_ORG_2184" "testeteknisa" "192\.168\.122\.5" "1521" "PDBORCL" "true" "false" "false" "testeteknisa" "false" "" "192\.168\.122\.54" "27020"

echo 'Update BIRT files --------------------------------------------------------'
$SCRIPTS_PATH/report_mnemonics.sh $SCRIPTS_PATH "" "" "" "http:\/\/testephp7-pebbian\.teknisa\.com" "E" "pdf" 
$SCRIPTS_PATH/birt_mnemonics.sh $SCRIPTS_PATH $REPORTS_CONFIG_PATH "192\.168\.122\.5" "1521" "PDBORCL" "USR_ORG_2184" "testeteknisa" "false" "false" "" "false"

# (Optional) -> Use it if you use Zeedhi's FileUploader component.
echo 'Update fileUploader.xml --------------------------------------------------'
$SCRIPTS_PATH/fileserver_mnemonics.sh $SCRIPTS_PATH "https:\/\/midia\.teknisa\.com\/" "a04119417eb46b2eeb7bb08bf04a6043" "1" "Production"

# (Optional) -> Use it if you use QR2 Reports
echo 'Update QR2 files ---------------------------------------------------------'
$SCRIPTS_PATH/qr2_mnemonics.sh $SCRIPTS_PATH "PDF" "http:\/\/qr2\.teknisa\.cloud\/" "1076" "false"

# Creates a Symbolycal link to your needed products
#ln -sf $NEEDED_PRODUCTS_TEST_PATH/login $MCSV_PRODUCT_PATH/modules
#ln -sf $NEEDED_PRODUCTS_TEST_PATH/acl   $MCSV_PRODUCT_PATH/modules
#ln -sf $NEEDED_PRODUCTS_TEST_PATH/teknisa/acl   $MCSV_PRODUCT_PATH/modules/teknisa

if [ ! -d $MCSV_PRODUCT_PATH/modules/login ]; then
	# (Optional) -> Copy Login
	echo 'Copy Login ---------------------------------------------------------------'
	cp -R $ZEEDHI_TEST_PRODUCTS_PATH/login $MCSV_PRODUCT_PATH/modules
fi

if [ ! -d $MCSV_PRODUCT_PATH/modules/acl ]; then
	# (Optional) -> Copy ACL
	echo 'Copy ACL -----------------------------------------------------------------'
	cp -R $ZEEDHI_TEST_PRODUCTS_PATH/acl $MCSV_PRODUCT_PATH/modules
	cp -R $ZEEDHI_TEST_PRODUCTS_PATH/teknisa/acl $MCSV_PRODUCT_PATH/modules/teknisa
fi

# (Optional) -> Use it to change products database
#echo 'Update db.xml ------------------------------------------------------------'
#rm -f  $MCSV_PRODUCT_PATH/backend/config/db.xml
#cp -Rf $MCSV_MODULE_SERVICE_PATH/backend/config/db.xml $MCSV_PRODUCT_PATH/backend/config/
#cp -Rf $MCSV_MODULE_SERVICE_PATH/backend/config/db.xml $ANOTHER_MCSV_PRODUCT_PATH/backend/config/

#echo 'LTS Test Step ------------------------------------------------------------'
#if [ ! -d "$MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules" ]; then
#     mkdir $MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules
#fi
#cp -Rf $MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/ 
#if [ ! -d "$MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/teknisa" ]; then
#     mkdir $MCSV_MODULE_SERVICE_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/teknisa
#fi
#cp -Rf $MCSV_MODULE_BACKEND_PATH $LTS_TEST_MCSV_PRODUCT_PATH/modules/teknisa/ 

#echo 'Update Login Step Microservice Module ------------------------------------'
#$SCRIPTS_PATH/update_login_step.sh $SCRIPTS_PATH $MCSV_MODULE_SERVICE_PATH "https:\/\/license\.teknisa\.com"
