var Rec15000_ChequeRecebidos_Service = function(ZHPromise, Rec15000_ChequeRecebidos_Repository){
    // Valida se as linhas do parametro rows possuem CDREDUCONT
    this.verificaContaFavorecido = function(rows) {
		// 0 - Todas as rows validas
		// 1 - Existem rows validas e invalidas
		// 2 - Somente rows invalidas
		var promise = ZHPromise.defer();
		var erro = 3;
		var rowsReturn = [];
		if(rows) {
			rows.forEach(function(row){
				if(!row.CDREDUCONT) {
					if(erro === 3) {
						erro = 2;
					}
					else {
						erro = 1;
					}
				}
				else{ 
					if(erro === 3) erro = 0;
					else if(erro === 2) erro = 1;
					rowsReturn.splice(rowsReturn.length, 1, row);
				} 
			}.bind(this));
		}
		else erro = 2;
		promise.resolve([rowsReturn,erro]);
		return promise;
	};
	
	// Retorna a data atual no formato DD/MM/YYYY
	this.getDataAtual = function() {
		var Data = new Date();
        var dataDia;
        var dataMonth;
        if(Data.getDate() < 10) dataDia = '0'+Data.getDate();
        else dataDia = Data.getDate();
        if(Data.getMonth() < 10) dataMonth = '0'+(Data.getMonth()+1);
        else dataMonth = Data.getMonth();
        return dataDia+'/'+dataMonth+'/'+Data.getFullYear();	
	};
	
	this.getCodLeitor = function(codCheque) {
		var codlength = codCheque.length;
		var arrayCode = codCheque.split('');
		var nrcheque = false;
		var compensacao = false;
		var banco = false;
		var agencia = false;
		var conta = false;
		nrcheque  = this.getPartCod(0, 5, arrayCode, codlength);
		if(codlength >= 7)  compensacao = this.getPartCod(6, 8, arrayCode, codlength);
		if(codlength >= 11) banco = this.getPartCod(9, 11, arrayCode, codlength);
		if(codlength >= 13) agencia = this.getPartCod(12, 15, arrayCode, codlength);
		if(codlength >= 17) conta = this.getPartCod(16, 31, arrayCode, codlength);
		return [nrcheque, compensacao, banco, agencia, conta];
	};
	
	this.getPartCod = function(tMin, tMax, arrayCode, codLength) {
		var resul = arrayCode[tMin].toString();
		for(var t = (tMin+1); (t <= tMax) && (t<=codLength-1); t++) {
			resul+= arrayCode[t];
		}
		return resul;
	};
};  
Configuration(function (ContextRegister){
    ContextRegister.register('Rec15000_ChequeRecebidos_Service', Rec15000_ChequeRecebidos_Service);
});
