function Rec11001_RelatorioCustomizavelTitulosReceberRecebidos_Controller(General, ScreenService, templateManager, ZhFilterPreferences, ZHPromise) {
    
    var self = this;
    
    self.changeInputValues = function(widget, preference) {
        var filterRow = preference.FILTER_ROW;
        
        validateStartEndValues(filterRow);
        parseCurrencyValues(filterRow);
    };
    
    self.buildFilter = function (widget, preference) {
        var filtro = widget.dataSourceFilter;
        var filterRow = preference.FILTER_ROW;
        
        validateStartEndValues(filterRow);
        parseCurrencyValues(filterRow);
        
        filtro.forEach(function(fil) {
            /*if (Array.isArray(fil.value)) {
                fil.value = fil.value.join("_");
            }*/
            switch (fil.name) {
                case 'CDEMPRESA':
                    fil.value = filterRow.CDEMPRESA ? filterRow.CDEMPRESA.join("_") : null;
                    break;
                case 'DTEMISSAOINI':
                    fil.value = filterRow.DTEMISSAO ? filterRow.DTEMISSAO.start : null;
                    break;
                case 'DTEMISSAOFIN':
                    fil.value = filterRow.DTEMISSAO ? filterRow.DTEMISSAO.end : null;
                    break;
                case 'DTENTRSAIDINI':
                    fil.value = filterRow.DTENTRSAID ? filterRow.DTENTRSAID.start : null;
                    break;
                case 'DTENTRSAIDFIN':
                    fil.value = filterRow.DTENTRSAID ? filterRow.DTENTRSAID.end : null;
                    break;
                case 'DTCNABRECINI':
                    fil.value = filterRow.DTCNABREC ? filterRow.DTCNABREC.start : null;
                    break;
                case 'DTCNABRECFIN':
                    fil.value = filterRow.DTCNABREC ? filterRow.DTCNABREC.end : null;
                    break;
                case 'DTVENBOLRECINI':
                    fil.value = filterRow.DTVENBOLREC ? filterRow.DTVENBOLREC.start : null;
                    break;
                case 'DTVENBOLRECFIN':
                    fil.value = filterRow.DTVENBOLREC ? filterRow.DTVENBOLREC.end : null;
                    break;
                case 'DTBAXINICIAL':
                    fil.value = filterRow.DTBAIXAREC ? filterRow.DTBAIXAREC.start : null;
                    break;
                case 'DTBAXFINAL':
                    fil.value = filterRow.DTBAIXAREC ? filterRow.DTBAIXAREC.end : null;
                    break;
                case 'TDTBAIXA':
                    fil.value = filterRow.DTBAIXAREC ? filterRow.DTBAIXAREC.start ? null : 'T' : 'T';
                    break;
                case 'DTLBAINICIAL':
                    fil.value = filterRow.DTLANCBAIXAR ? filterRow.DTLANCBAIXAR.start : null;
                    break;
                case 'DTLBAFINAL':
                    fil.value = filterRow.DTLANCBAIXAR ? filterRow.DTLANCBAIXAR.end : null;
                    break;
                case 'TDTLBAIXA':
                    fil.value = filterRow.DTLANCBAIXAR ? filterRow.DTLANCBAIXAR.start ? null : 'T' : 'T';
                    break;
                case 'VRBAIXARECINI':
                    fil.value = filterRow.VRBAIXARECINI && filterRow.VRBAIXARECFIN ? filterRow.VRBAIXARECINI : null;
                    break;
                case 'VRBAIXARECFIN':
                    fil.value = filterRow.VRBAIXARECINI && filterRow.VRBAIXARECFIN ? filterRow.VRBAIXARECFIN : null;
                    break;
                case 'TVRBAIXA':
                    fil.value = filterRow.VRBAIXARECINI && filterRow.VRBAIXARECFIN ? null : 'T';
                    break;
            }
        });
        for(var i = 0; i < filtro.length; i++) {
            if(filtro[i].name === 'DTEMISSAO' ||
               filtro[i].name === 'DTENTRSAID' ||
               filtro[i].name === 'DTVENBOLREC' ||
               filtro[i].name === 'DTCNABREC' ||
               filtro[i].name === 'DTBAIXAREC' ||
               filtro[i].name === 'DTLANCBAIXAR' ) {
                filtro.splice(i, 1);
                i--;
            }
        }
        
        preference.CUSTOM_FILTER_ROW = {
            'CDCLIENTE'    : preference.FILTER_ROW.CDCLIENTE,
            'IDSTATUSREC'  : preference.FILTER_ROW.IDSTATUSREC,
            'IDSTATBREC'   : preference.FILTER_ROW.IDSTATBREC,
            'IDSTATUSEMIT' : preference.FILTER_ROW.IDSTATUSEMIT,
            'IDPROTESTREC' : preference.FILTER_ROW.IDPROTESTREC,
            'CDTIPOOPER'   : preference.FILTER_ROW.CDTIPOOPER,
            'NMFILIEMIT'   : preference.FILTER_ROW.NMFILIEMIT,
            'CDFILIALNF'   : preference.FILTER_ROW.CDFILIALNF,
            'CDTPCTRECEB'  : preference.FILTER_ROW.CDTPCTRECEB,
            'CDCLASSFINA'  : preference.FILTER_ROW.CDCLASSFINA,
            'CDVENDEDOR'   : preference.FILTER_ROW.CDVENDEDOR,
            'IDSTATUS'     : preference.FILTER_ROW.IDSTATUS,
            'IDSITUCNABR'  : preference.FILTER_ROW.IDSITUCNABR,
            'CDTPBAIXAREC' : preference.FILTER_ROW.CDTPBAIXAREC,
            'IDSTATUSBREC' : preference.FILTER_ROW.IDSTATUSBREC
        };
    };
    
    /*
     * Verificação para igualar valores iniciais e finais do filtro, no caso
     * do usuário preencher um e deixar o outro em branco. Isso irá fazer
     * com que a query retorne somente resultados que sejam exatamente os  
     * mesmos valores inseridos em um dos campos.
     */
    var validateStartEndValues = function(filterRow) {
        // Verifica valor do boleto inicial e final.
        filterRow.VRBOLRECINI = filterRow.VRBOLRECINI || filterRow.VRBOLRECFIN || null;
        filterRow.VRBOLRECFIN = filterRow.VRBOLRECFIN || filterRow.VRBOLRECINI;
        
        // Verifica valor líquido inicial e final.
        filterRow.VRFINALBRECINI = filterRow.VRFINALBRECINI || filterRow.VRFINALBRECFIN || null;
        filterRow.VRFINALBRECFIN = filterRow.VRFINALBRECFIN || filterRow.VRFINALBRECINI;
        
        // Verifica nota fiscal inicial e final.
        filterRow.NRNOTAFISCINI = filterRow.NRNOTAFISCINI || filterRow.NRNOTAFISCFIN || null;
        filterRow.NRNOTAFISCFIN = filterRow.NRNOTAFISCFIN || filterRow.NRNOTAFISCINI;
        
        // Verifica valor da baixa inicial e final.
        filterRow.VRBAIXARECINI = filterRow.VRBAIXARECINI || filterRow.VRBAIXARECFIN || null;
        filterRow.VRBAIXARECFIN = filterRow.VRBAIXARECFIN || filterRow.VRBAIXARECINI;
        
        // Verifica número remessa inicial e final.
        filterRow.NRCNABRECREMINI = filterRow.NRCNABRECREMINI || filterRow.NRCNABRECREMFIN || null;
        filterRow.NRCNABRECREMFIN = filterRow.NRCNABRECREMFIN || filterRow.NRCNABRECREMINI;
        
        // Verifica número retorno inicial e final.
        filterRow.NRCNABRECRETINI = filterRow.NRCNABRECRETINI || filterRow.NRCNABRECRETFIN || null;
        filterRow.NRCNABRECRETFIN = filterRow.NRCNABRECRETFIN || filterRow.NRCNABRECRETINI;
        
        // Verifica valor remessa inicial e final.
        filterRow.VRTOTBOLCNABRECINI = filterRow.VRTOTBOLCNABRECINI || filterRow.VRTOTBOLCNABRECFIN || null;
        filterRow.VRTOTBOLCNABRECFIN = filterRow.VRTOTBOLCNABRECFIN || filterRow.VRTOTBOLCNABRECINI;
    };
    
    /*
     * Função para realizar um parse nos valores monetários inseridos no filtro.
     */
    var parseCurrencyValues = function(filterRow) {
        // Realiza o parse nos valores do boleto inicial e final.
        filterRow.VRBOLRECINI = (filterRow.VRBOLRECINI !== null) ? $.currency.unmaskString(filterRow.VRBOLRECINI) : null; 
        filterRow.VRBOLRECFIN = (filterRow.VRBOLRECFIN !== null) ? $.currency.unmaskString(filterRow.VRBOLRECFIN) : null; 
        
        // Realiza o parse nos valores líquidos inicial e final.
        filterRow.VRFINALBRECINI = (filterRow.VRFINALBRECINI !== null) ? $.currency.unmaskString(filterRow.VRFINALBRECINI) : null; 
        filterRow.VRFINALBRECFIN = (filterRow.VRFINALBRECFIN !== null) ? $.currency.unmaskString(filterRow.VRFINALBRECFIN) : null; 
        
        // Realiza o parse nos valores da baixa inicial e final.
        filterRow.VRBAIXARECINI = (filterRow.VRBAIXARECINI !== null) ? $.currency.unmaskString(filterRow.VRBAIXARECINI) : null; 
        filterRow.VRBAIXARECFIN = (filterRow.VRBAIXARECFIN !== null) ? $.currency.unmaskString(filterRow.VRBAIXARECFIN) : null; 
        // Realiza o parse nos valores de remessa inicial e final.
        filterRow.VRTOTBOLCNABRECINI = (filterRow.VRTOTBOLCNABRECINI !== null) ? $.currency.unmaskString(filterRow.VRTOTBOLCNABRECINI) : null; 
        filterRow.VRTOTBOLCNABRECFIN = (filterRow.VRTOTBOLCNABRECFIN !== null) ? $.currency.unmaskString(filterRow.VRTOTBOLCNABRECFIN) : null; 
    };
    
    self.openFilterTitulosAReceber = function(widgetTitulosAReceber){
        self.buscaDadosIniciaisFiltro(widgetTitulosAReceber).then(function(){
            var rowSetFilter = {
                'DTVENBOLREC' : widgetTitulosAReceber.DTVENBOLREC,
                'CDEMPRESA'   : [widgetTitulosAReceber.empresa.CDEMPRESA]
            };
            
            ZhFilterPreferences.setOriginalFilter(widgetTitulosAReceber.id, rowSetFilter);
            ZhFilterPreferences.openFilterWidget(widgetTitulosAReceber, rowSetFilter).then( function(sucess){
                widgetTitulosAReceber.getField('CDTPCTRECEB').dataSourceFilter[0].value = widgetTitulosAReceber.empresa.CDEMPRESA;
                widgetTitulosAReceber.getField('CDTPCTRECEB').reload();
            });
        });
    };
    
    self.buscaDadosIniciaisFiltro = function(widgetTitulosAReceber) {
        var deferred = ZHPromise.defer();
        self.buscaPadraoEmpresa(widgetTitulosAReceber).then(function(){
            self.buscaPadraoIntervaloVencimento(widgetTitulosAReceber).then(function(){
                deferred.resolve();        
            });    
        });
        
        return deferred.promise;
    };
    
    self.buscaPadraoEmpresa = function(widget) {
        var deferred = ZHPromise.defer();
        var filterFilial = [{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"}];
        var routeFilial = 'fin#/crud/filial';
        General.callRestEngine(routeFilial, 'FilterData', filterFilial).then(function(response_filial){
            var filial   = response_filial.dataset.filial[0];
            var routeEmpresa = 'fin#/crud/empresa';
            var filterEmpresa = [{"name": "CDEMPRESA", "operator": "=", "value": filial.CDEMPRESA}];
            General.callRestEngine(routeEmpresa, 'FilterData', filterEmpresa).then(function(response_empresa){
                var empresa = response_empresa.dataset.empresa[0];
                widget.empresa = empresa;
                deferred.resolve();
            });
        });
        
        return deferred.promise;
    };
    
    self.buscaPadraoIntervaloVencimento = function (widget){
        var deferred = ZHPromise.defer();
        var geralrec     = self.buscaGeralRec();
        var paramestoque = self.buscaParamEstoque();

        ZHPromise.all([geralrec, paramestoque]).then(function(response){
            geralrec     = response[0].dataset.geral_rec[0];
            paramestoque = response[1].dataset.paramestoque_processamento[0];

            var qtdiaantlanr = geralrec?geralrec.QTDIAANTLANR?geralrec.QTDIAANTLANR:0:0;
            var qtdiaapolanr = geralrec?geralrec.QTDIAAPOLANR?geralrec.QTDIAAPOLANR:0:0;
            var dtprocessa   = paramestoque?paramestoque.DTPROCESSA?paramestoque.DTPROCESSA:moment():moment();

            var start = moment(dtprocessa, 'DD/MM/YYYY').subtract(qtdiaantlanr, 'days').format('DD/MM/YYYY');
            var end   = moment(dtprocessa, 'DD/MM/YYYY').add(qtdiaapolanr, 'days').format('DD/MM/YYYY');

            widget.DTVENBOLREC = {start : start, end : end};
            deferred.resolve();
        });
        return deferred.promise;
    };
    
    self.buscaGeralRec = function(){
        return General.callRestEngine(
            'fin#/crud/geral_rec',
            'FilterData',
            []
        );
    };
    
    self.buscaParamEstoque = function(cdFilialOpcional) {
        var filter = [{"name": "CDFILIAL", "operator": "=", "value": 'FILIAL_LOGADA'}];
        return General.callRestEngine(
            'fin#/crud/paramestoque_processamento',
            'FilterData',
            filter
        );
    };
    
    
    this.changeHeaderValues = function(widget){
        var codigo; 
        /*var nmempresa = widget.owner.dataSource.data[0].NMEMPRESA;
        widget.owner.dataSourceFilter.forEach(function(empresa){
           if(empresa.name == 'CDEMPRESA'){
               codigo = empresa.value;
           } 
        });
        
        var cdempresa = {
            'label' : "Empresa",
            'value' : "é igual a".concat(codigo).concat(' - ').concat(nmempresa)
        };*/
        
        var filter = widget.e.metadata.filter;
        var newFilter = [];
        //newFilter.push(cdempresa);
        filter.forEach(function(x){
            if(x.value != "é igual a."){
                newFilter.push(x);
            }
        });
        
        var correctFilter = [];
        var value;
        newFilter.forEach(function(aux){
            if(aux.value.match(/é igual a/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }else if(aux.value.match(/está entre/)){
                value = aux.value.substr(11);
                aux.value = value;
                correctFilter.push(aux);
            }
        });
        
        widget.e.metadata.filter = correctFilter;    
        
        
    };
    
    self.changeTipoConta = function(widget){
        var filtroEmpresa = "";
        widget.getField('CDEMPRESA').value().forEach(function(empresa){
            filtroEmpresa = filtroEmpresa+"_"+empresa;
        });
            
        widget.getField('CDTPCTRECEB').dataSourceFilter[0].value = filtroEmpresa;
        widget.getField('CDTPCTRECEB').clearValue();
        widget.getField('CDTPCTRECEB').reload();
    };
    
}

Configuration(function (ContextRegister) {
	ContextRegister.register('Rec11001_RelatorioCustomizavelTitulosReceberRecebidos_Controller', Rec11001_RelatorioCustomizavelTitulosReceberRecebidos_Controller);
});